
var startNode = null;
var goalNode = null;
//var path = ["Tuck", "Buchanan", "Tuck Dr"];
var path = [];

var pickNode = function(x, y) {
  for (var key in mapGraph) {
    if (mapGraph.hasOwnProperty(key)) {
        var node = mapGraph[key];
        var dx = x - node.x;
        var dy = y - node.y;
        if(dx * dx + dy * dy < 36) {
          return node;
        }
      }
    }
};

var drawNode = function(processingInstance, node) {
    processingInstance.ellipse(node.x, node.y, 12, 12);
};


var drawNodes = function(p) {

  p.strokeWeight(1);
  p.stroke(0, 0, 0);
  for (var key in mapGraph) {
    if (mapGraph.hasOwnProperty(key)) {
        var node = mapGraph[key];
        p.fill(100, 100, 255);
        drawNode(p, node);

      }
    }

    if(goalNode) {
      p.fill(255, 100, 100);
      drawNode(p, goalNode);
    }

    if(startNode) {
      p.fill(100, 255, 100);
      drawNode(p, startNode);
    }
};

var drawPath = function(p) {

  p.strokeWeight(4);
  p.stroke(255, 0, 0);
  if(path.length > 1) {
    var firstNode = mapGraph[path[0]];
    var ox = firstNode.x;
    var oy = firstNode.y;

    for(var i = 1; i < path.length; i++) {
      var node = mapGraph[path[i]];

      p.line(ox, oy, node.x, node.y);
      ox = node.x;
      oy = node.y;
    }

  }

};



var sketchProc = function(p) {

  p.size(1012, 811);
  var mapImage = p.loadImage("dartmouth_map.png");

  console.log("loading map");

  p.draw = function() {
    //console.log("test");
    p.image(mapImage, 0, 0);
    drawPath(p);
    drawNodes(p);


  };

  p.mouseMoved = function() {
    var node = pickNode(p.mouseX, p.mouseY);
    if(node) {
      //console.log(node.name);
      goalNode = node;

      // if there is also a start, do the graph search
      if(startNode) {
        //console.log("time to search");
        path = graphSearch(mapGraph, startNode.name, goalNode.name);
      }


    }
  };


  p.mousePressed = function() {
    var node = pickNode(p.mouseX, p.mouseY);
    if(node) {
      //console.log(node.name);
      startNode = node;

    }
  };


};
